//
// Form.cpp
//

#include <Form.h>

#include <Application.h>

///////////////////////////
// TFormView implementation
TFormView::TFormView(TForm *parent, const char *name)
: BView(
		parent->Bounds()
	, name
	, B_FOLLOW_ALL_SIDES
	, B_WILL_DRAW | B_FULL_UPDATE_ON_RESIZE | B_FRAME_EVENTS
	)
, m_ParentForm(parent)
{
	m_ParentForm->AddChild(this);
}


///////////////////////
// TForm implementation
TForm::TForm(
	BRect frame
, const char *title
, window_type type
, uint32 flags
, uint32 workspaces
, bool bMainForm
)
: BWindow(frame, title, type, flags, workspaces)
, m_FormView(0)
, m_IsMainForm(bMainForm)
, m_MainMenu(0)
{
}

TForm::TForm(
	BRect frame
, const char *title
, window_look look
, window_feel feel
, uint32 flags
, uint32 workspaces
, bool bMainForm
)
: BWindow(frame, title, look, feel, flags, workspaces)
, m_FormView(0)
, m_IsMainForm(bMainForm)
{
}  
 
 // BWindow overrides
void TForm::Show(void)
{
	BWindow::Show();
	FormShow();
}

void TForm::Hide(void)
{
	BWindow::Hide();
	FormHide();
}

void TForm::Minimize(bool minimize)
{
	BWindow::Minimize(minimize);
	FormMinimize();
}

void TForm::Zoom(BPoint origin, float width, float height)
{
	BWindow::Zoom(origin, width, height);
	FormZoom();
}

void TForm::FrameMoved(BPoint origin)
{
	BWindow::FrameMoved(origin);
}

void TForm::FrameResized(float width, float height)
{	
	BWindow::FrameResized(width, height);
}

void TForm::MenusBeginning(void)
{
	BWindow::MenusBeginning();
}

void TForm::MenusEnded(void)
{
	BWindow::MenusEnded();
}

void TForm::ScreenChanged(BRect frame, color_space mode)
{
	BWindow::ScreenChanged(frame, mode);
}

void TForm::Activate(bool activate)
{
	BWindow::Activate(activate);
}

void TForm::WindowActivated(bool active)
{
	BWindow::WindowActivated(active);
}

void TForm::WorkspaceActivated(int32 workspace, bool active)
{
	BWindow::WorkspaceActivated(workspace, active);
}

void TForm::WorkspacesChanged(uint32 oldWorkspaces, uint32 newWorkspaces)
{
	BWindow::WorkspacesChanged(oldWorkspaces, newWorkspaces);
}

bool TForm::QuitRequested(void)
{
  if(IsMainForm()) 
  	be_app->PostMessage(B_QUIT_REQUESTED);
  return true;
}


// eof
