//
// StringList.h
//
#ifndef _StringList_H
#define _StringList_H

#include <List.h>

class TStringList: public BList {
public:
	TStringList(int32 size = 20)
	: BList(size)
	{}
	
	TStringList(const TStringList &other)
	: BList(other)
	{}
	
	virtual ~TStringList() 
	{
	}
	
	virtual void Add(const char *s)
	{
		if(s)
		{
			char *buf = new char[strlen(s)+1];
			strcpy(buf, s);
			AddItem((void *)s);
		}
	}
	
	const char *operator[](uint32 index) {return (char *)ItemAt(index); }
	
	int32 IndexOf(const char *s)
	{
		int32 result = -1;
		for(int32 i = 0; i < CountItems(); i++)
		{
			if(0 == strcmp((char *)ItemAt(i), s))
			{	result = i; break; }
		}
		return result;
	}
	
	virtual void Clear(bool delStrings = true)
	{
		if(delStrings)
		{
			for(int32 i = 0; i < CountItems(); i++)
			{
				char *p = (char *)ItemAt(i);
				if(p) delete [] p;
			}
		}
		MakeEmpty();
	}
};


#endif // _StringList_H